/// @file xed-encoder-4.c

// This file was automatically generated.
// Do not edit this file.

/*BEGIN_LEGAL

Copyright (c) 2021 Intel Corporation

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
  
END_LEGAL */
#include "xed-internal-header.h"
#include "xed-encoder.h"
#include "xed-encode-private.h"
#include "xed-enc-operand-lu.h"
#include "xed-operand-accessors.h"
xed_uint_t xed_encode_nonterminal_VSIB_ENC_BASE_EMIT(xed_encoder_request_t* xes)
{
/* VSIB_ENC_BASE()::
	BASE0=XED_REG_AX EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=0 value=0x0
	BASE0=XED_REG_EAX EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=0 value=0x0
	BASE0=XED_REG_RAX EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=0 value=0x0
	BASE0=XED_REG_CX EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=1 value=0x1
	BASE0=XED_REG_ECX EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=1 value=0x1
	BASE0=XED_REG_RCX EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=1 value=0x1
	BASE0=XED_REG_DX EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=2 value=0x2
	BASE0=XED_REG_EDX EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=2 value=0x2
	BASE0=XED_REG_RDX EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=2 value=0x2
	BASE0=XED_REG_BX EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=3 value=0x3
	BASE0=XED_REG_EBX EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=3 value=0x3
	BASE0=XED_REG_RBX EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=3 value=0x3
	BASE0=XED_REG_SP EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=4 value=0x4
	BASE0=XED_REG_ESP EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=4 value=0x4
	BASE0=XED_REG_RSP EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=4 value=0x4
	BASE0=XED_REG_SI EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=6 value=0x6
	BASE0=XED_REG_ESI EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=6 value=0x6
	BASE0=XED_REG_RSI EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=6 value=0x6
	BASE0=XED_REG_DI EASZ=1  ->	FB REXB=0 value=0x0 	FB SIBBASE=7 value=0x7
	BASE0=XED_REG_EDI EASZ=2  ->	FB REXB=0 value=0x0 	FB SIBBASE=7 value=0x7
	BASE0=XED_REG_RDI EASZ=3  ->	FB REXB=0 value=0x0 	FB SIBBASE=7 value=0x7
	BASE0=XED_REG_R8W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=0 value=0x0
	BASE0=XED_REG_R8D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=0 value=0x0
	BASE0=XED_REG_R8 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=0 value=0x0
	BASE0=XED_REG_R9W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=1 value=0x1
	BASE0=XED_REG_R9D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=1 value=0x1
	BASE0=XED_REG_R9 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=1 value=0x1
	BASE0=XED_REG_R10W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=2 value=0x2
	BASE0=XED_REG_R10D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=2 value=0x2
	BASE0=XED_REG_R10 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=2 value=0x2
	BASE0=XED_REG_R11W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=3 value=0x3
	BASE0=XED_REG_R11D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=3 value=0x3
	BASE0=XED_REG_R11 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=3 value=0x3
	BASE0=XED_REG_R12W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=4 value=0x4
	BASE0=XED_REG_R12D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=4 value=0x4
	BASE0=XED_REG_R12 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=4 value=0x4
	BASE0=XED_REG_R14W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=6 value=0x6
	BASE0=XED_REG_R14D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=6 value=0x6
	BASE0=XED_REG_R14 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=6 value=0x6
	BASE0=XED_REG_R15W EASZ=1  ->	FB REXB=1 value=0x1 	FB SIBBASE=7 value=0x7
	BASE0=XED_REG_R15D EASZ=2  ->	FB REXB=1 value=0x1 	FB SIBBASE=7 value=0x7
	BASE0=XED_REG_R15 EASZ=3  ->	FB REXB=1 value=0x1 	FB SIBBASE=7 value=0x7
	BASE0=@  ->	nt NT[DISP_WIDTH_32] 	FB REXB=0 value=0x0 	FB SIBBASE=5 value=0x5
	BASE0=XED_REG_BP EASZ=1  ->	nt NT[DISP_WIDTH_8_32] 	FB REXB=0 value=0x0 	FB SIBBASE=5 value=0x5
	BASE0=XED_REG_EBP EASZ=2  ->	nt NT[DISP_WIDTH_8_32] 	FB REXB=0 value=0x0 	FB SIBBASE=5 value=0x5
	BASE0=XED_REG_RBP EASZ=3  ->	nt NT[DISP_WIDTH_8_32] 	FB REXB=0 value=0x0 	FB SIBBASE=5 value=0x5
	BASE0=XED_REG_R13W EASZ=1  ->	nt NT[DISP_WIDTH_8_32] 	FB REXB=1 value=0x1 	FB SIBBASE=5 value=0x5
	BASE0=XED_REG_R13D EASZ=2  ->	nt NT[DISP_WIDTH_8_32] 	FB REXB=1 value=0x1 	FB SIBBASE=5 value=0x5
	BASE0=XED_REG_R13 EASZ=3  ->	nt NT[DISP_WIDTH_8_32] 	FB REXB=1 value=0x1 	FB SIBBASE=5 value=0x5
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_VSIB_ENC_BASE;
/* 91 */ if (iform==91) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 14 */ if (iform==14) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 41 */ if (iform==41) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 95 */ if (iform==95) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 18 */ if (iform==18) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 45 */ if (iform==45) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 22 */ if (iform==22) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 49 */ if (iform==49) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 8 */ if (iform==8) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 26 */ if (iform==26) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 53 */ if (iform==53) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 12 */ if (iform==12) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 30 */ if (iform==30) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 57 */ if (iform==57) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 20 */ if (iform==20) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 38 */ if (iform==38) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 65 */ if (iform==65) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 24 */ if (iform==24) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 42 */ if (iform==42) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 69 */ if (iform==69) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 28 */ if (iform==28) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 46 */ if (iform==46) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 73 */ if (iform==73) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 32 */ if (iform==32) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 50 */ if (iform==50) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 77 */ if (iform==77) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 36 */ if (iform==36) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 54 */ if (iform==54) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 81 */ if (iform==81) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 40 */ if (iform==40) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 58 */ if (iform==58) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 85 */ if (iform==85) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 44 */ if (iform==44) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 62 */ if (iform==62) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 89 */ if (iform==89) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 52 */ if (iform==52) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 70 */ if (iform==70) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 97 */ if (iform==97) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 56 */ if (iform==56) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 74 */ if (iform==74) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 101 */ if (iform==101) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 71 */ if (iform==71) {
    xed_encode_nonterminal_DISP_WIDTH_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 16 */ if (iform==16) {
    xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 34 */ if (iform==34) {
    xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 61 */ if (iform==61) {
    xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 48 */ if (iform==48) {
    xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 66 */ if (iform==66) {
    xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 93 */ if (iform==93) {
    xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xes);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_VSIB_ENC_SCALE_EMIT(xed_encoder_request_t* xes)
{
/* VSIB_ENC_SCALE()::
	SCALE=0  ->	FB SIBSCALE=0 value=0x0
	SCALE=1  ->	FB SIBSCALE=0 value=0x0
	SCALE=2  ->	FB SIBSCALE=1 value=0x1
	SCALE=4  ->	FB SIBSCALE=2 value=0x2
	SCALE=8  ->	FB SIBSCALE=3 value=0x3
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_VSIB_ENC_EMIT(xed_encoder_request_t* xes)
{
/* VSIB_ENC()::
	DUMMY=0 SIBBASE[bbb]=* SIBINDEX[iii]=* SIBSCALE[ss]=*  ->	emit ss_iii_bbb emit_type=letters nbits=8
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_VSIB_ENC;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_sibscale(xes)<< 6)|(xed3_operand_get_sibindex(xes)<< 3)|(xed3_operand_get_sibbase(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_VSIB_ENC_INDEX_XMM_EMIT(xed_encoder_request_t* xes)
{
/* VSIB_ENC_INDEX_XMM()::
	INDEX=XED_REG_XMM0  ->	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_XMM1  ->	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_XMM2  ->	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_XMM3  ->	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_XMM4  ->	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_XMM5  ->	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_XMM6  ->	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_XMM7  ->	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_XMM8  ->	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_XMM9  ->	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_XMM10  ->	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_XMM11  ->	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_XMM12  ->	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_XMM13  ->	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_XMM14  ->	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_XMM15  ->	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_VSIB_ENC_INDEX_YMM_EMIT(xed_encoder_request_t* xes)
{
/* VSIB_ENC_INDEX_YMM()::
	INDEX=XED_REG_YMM0  ->	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_YMM1  ->	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_YMM2  ->	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_YMM3  ->	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_YMM4  ->	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_YMM5  ->	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_YMM6  ->	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_YMM7  ->	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_YMM8  ->	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_YMM9  ->	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_YMM10  ->	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_YMM11  ->	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_YMM12  ->	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_YMM13  ->	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_YMM14  ->	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_YMM15  ->	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_DISP_WIDTH_8_32_EMIT(xed_encoder_request_t* xes)
{
/* DISP_WIDTH_8_32()::
	DISP_WIDTH=8  ->	nothing
	DISP_WIDTH=32  ->	nothing
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE1_4X_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE1_4X()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_EVEX_62_REXR_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_62_REXR_ENC()::
	MODE=2 REXR=1  ->	emit 0x62 emit_type=numeric value=0x62 nbits=8 	emit 0b0 emit_type=numeric value=0x0 nbits=1
	MODE=2 REXR=0  ->	emit 0x62 emit_type=numeric value=0x62 nbits=8 	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXR=0  ->	emit 0x62 emit_type=numeric value=0x62 nbits=8 	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXR=1  ->	FB ERROR=XED_ERROR_GENERAL_ERROR
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_62_REXR_ENC;
/* 5 */ if (iform==5) {
    xed_encoder_request_encode_emit(xes,8,0x62);
    xed_encoder_request_encode_emit(xes,1,0x0);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,8,0x62);
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,8,0x62);
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_REXX_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_REXX_ENC()::
	MODE=2 REXX=1  ->	emit 0b0 emit_type=numeric value=0x0 nbits=1
	MODE=2 REXX=0  ->	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXX=0  ->	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXX=1  ->	FB ERROR=XED_ERROR_GENERAL_ERROR
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_REXX_ENC;
/* 5 */ if (iform==5) {
    xed_encoder_request_encode_emit(xes,1,0x0);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_REXB_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_REXB_ENC()::
	MODE=2 REXB=1  ->	emit 0b0 emit_type=numeric value=0x0 nbits=1
	MODE=2 REXB=0  ->	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXB=0  ->	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXB=1  ->	FB ERROR=XED_ERROR_GENERAL_ERROR
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_REXB_ENC;
/* 5 */ if (iform==5) {
    xed_encoder_request_encode_emit(xes,1,0x0);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_REXRR_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_REXRR_ENC()::
	MODE=2 REXRR=1  ->	emit 0b0 emit_type=numeric value=0x0 nbits=1
	MODE=2 REXRR=0  ->	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXRR=0  ->	emit 0b1 emit_type=numeric value=0x1 nbits=1
	MODE=1 REXRR=1  ->	FB ERROR=XED_ERROR_GENERAL_ERROR
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_REXRR_ENC;
/* 5 */ if (iform==5) {
    xed_encoder_request_encode_emit(xes,1,0x0);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,1,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_MAP_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_MAP_ENC()::
	MAP=0  ->	emit 0b0000 emit_type=numeric value=0x0 nbits=4
	MAP=1  ->	emit 0b0001 emit_type=numeric value=0x1 nbits=4
	MAP=2  ->	emit 0b0010 emit_type=numeric value=0x2 nbits=4
	MAP=3  ->	emit 0b0011 emit_type=numeric value=0x3 nbits=4
	MAP=5  ->	emit 0b0101 emit_type=numeric value=0x5 nbits=4
	MAP=6  ->	emit 0b0110 emit_type=numeric value=0x6 nbits=4
	MAP=4  ->	FB ERROR=XED_ERROR_GENERAL_ERROR
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_MAP_ENC;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,4,0x0);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,4,0x1);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,4,0x2);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,4,0x3);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 6 */ if (iform==6) {
    xed_encoder_request_encode_emit(xes,4,0x5);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 7 */ if (iform==7) {
    xed_encoder_request_encode_emit(xes,4,0x6);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_REXW_VVVV_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_REXW_VVVV_ENC()::
	DUMMY=0 REXW[w]=* VEXDEST3[u]=* VEXDEST210[ddd]=*  ->	emit w emit_type=letters nbits=1 	emit u_ddd emit_type=letters nbits=4
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_REXW_VVVV_ENC;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,1,(xed3_operand_get_rexw(xes)));
    xed_encoder_request_encode_emit(xes,4,(xed3_operand_get_vexdest3(xes)<< 3)|(xed3_operand_get_vexdest210(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_UPP_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_UPP_ENC()::
	VEX_PREFIX=0  ->	emit 0b100 emit_type=numeric value=0x4 nbits=3
	VEX_PREFIX=1  ->	emit 0b101 emit_type=numeric value=0x5 nbits=3
	VEX_PREFIX=3  ->	emit 0b110 emit_type=numeric value=0x6 nbits=3
	VEX_PREFIX=2  ->	emit 0b111 emit_type=numeric value=0x7 nbits=3
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_EVEX_UPP_ENC;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,3,0x4);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,3,0x5);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,3,0x6);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,3,0x7);
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_EVEX_LL_ENC_EMIT(xed_encoder_request_t* xes)
{
/* EVEX_LL_ENC()::
	ROUNDC=0 SAE=0 VL=0  ->	FB LLRC=0 value=0x0
	ROUNDC=0 SAE=0 VL=1  ->	FB LLRC=1 value=0x1
	ROUNDC=0 SAE=0 VL=2  ->	FB LLRC=2 value=0x2
	ROUNDC=0 SAE=1 VL=0  ->	FB LLRC=0 value=0x0 	FB BCRC=1 value=0x1
	ROUNDC=1 SAE=1 VL=0  ->	FB LLRC=0 value=0x0 	FB BCRC=1 value=0x1
	ROUNDC=2 SAE=1 VL=0  ->	FB LLRC=1 value=0x1 	FB BCRC=1 value=0x1
	ROUNDC=3 SAE=1 VL=0  ->	FB LLRC=2 value=0x2 	FB BCRC=1 value=0x1
	ROUNDC=4 SAE=1 VL=0  ->	FB LLRC=3 value=0x3 	FB BCRC=1 value=0x1
	ROUNDC=0 SAE=1 VL=2  ->	FB LLRC=0 value=0x0 	FB BCRC=1 value=0x1
	ROUNDC=1 SAE=1 VL=2  ->	FB LLRC=0 value=0x0 	FB BCRC=1 value=0x1
	ROUNDC=2 SAE=1 VL=2  ->	FB LLRC=1 value=0x1 	FB BCRC=1 value=0x1
	ROUNDC=3 SAE=1 VL=2  ->	FB LLRC=2 value=0x2 	FB BCRC=1 value=0x1
	ROUNDC=4 SAE=1 VL=2  ->	FB LLRC=3 value=0x3 	FB BCRC=1 value=0x1
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_AVX512_EVEX_BYTE3_ENC_EMIT(xed_encoder_request_t* xes)
{
/* AVX512_EVEX_BYTE3_ENC()::
	ZEROING[z]=* LLRC[nn]=* BCRC[b]=* VEXDEST4=0 MASK[aaa]=*  ->	emit z_nn_b emit_type=letters nbits=4 	emit 0b1 emit_type=numeric value=0x1 nbits=1 	emit aaa emit_type=letters nbits=3
	ZEROING[z]=* LLRC[nn]=* BCRC[b]=* VEXDEST4=1 MASK[aaa]=*  ->	emit z_nn_b emit_type=letters nbits=4 	emit 0b0 emit_type=numeric value=0x0 nbits=1 	emit aaa emit_type=letters nbits=3
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_AVX512_EVEX_BYTE3_ENC;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,4,(xed3_operand_get_zeroing(xes)<< 3)|(xed3_operand_get_llrc(xes)<< 1)|(xed3_operand_get_bcrc(xes)));
    xed_encoder_request_encode_emit(xes,1,0x1);
    xed_encoder_request_encode_emit(xes,3,(xed3_operand_get_mask(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,4,(xed3_operand_get_zeroing(xes)<< 3)|(xed3_operand_get_llrc(xes)<< 1)|(xed3_operand_get_bcrc(xes)));
    xed_encoder_request_encode_emit(xes,1,0x0);
    xed_encoder_request_encode_emit(xes,3,(xed3_operand_get_mask(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_AVX512_ROUND_EMIT(xed_encoder_request_t* xes)
{
/* AVX512_ROUND()::
	ROUNDC=1  ->	FB LLRC=0 value=0x0 	FB BCRC=1 value=0x1
	ROUNDC=2  ->	FB LLRC=1 value=0x1 	FB BCRC=1 value=0x1
	ROUNDC=3  ->	FB LLRC=2 value=0x2 	FB BCRC=1 value=0x1
	ROUNDC=4  ->	FB LLRC=3 value=0x3 	FB BCRC=1 value=0x1
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_SAE_EMIT(xed_encoder_request_t* xes)
{
/* SAE()::
	SAE=1  ->	FB BCRC=1 value=0x1
	SAE=0  ->	FB BCRC=0 value=0x0
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_128_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_128_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_64_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_64_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_32_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_32_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_16_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_16_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_8_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_8_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_4_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_4_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_2_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_2_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ESIZE_1_BITS_EMIT(xed_encoder_request_t* xes)
{
/* ESIZE_1_BITS()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_MOVDDUP_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_MOVDDUP()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_FULLMEM_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_FULLMEM()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_HALFMEM_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_HALFMEM()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_QUARTERMEM_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_QUARTERMEM()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_EIGHTHMEM_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_EIGHTHMEM()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_READER_BYTE_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_READER_BYTE()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_READER_WORD_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_READER_WORD()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_D_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_LDOP_D()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_Q_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_LDOP_Q()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_BYTE_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_STORE_BYTE()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_WORD_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_STORE_WORD()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE1_BYTE_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE1_BYTE()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE1_WORD_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE1_WORD()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_SCALAR_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_SCALAR()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE1_SUBDWORD_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE1_SUBDWORD()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_READER_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_READER()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_READER_SUBDWORD_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_READER_SUBDWORD()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_LDOP_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_LDOP()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_STORE()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GPR_WRITER_STORE_SUBDWORD_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GPR_WRITER_STORE_SUBDWORD()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_MEM128_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_MEM128()::
	BCAST!=0  ->	FB ERROR=XED_ERROR_GENERAL_ERROR
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE1_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE1()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_GSCAT_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_GSCAT()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE2_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE2()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE4_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE4()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_TUPLE8_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_TUPLE8()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_FULL_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_FULL()::
	BCAST!=0  ->	FB BCRC=1 value=0x1
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_HALF_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_HALF()::
	BCAST!=0  ->	FB BCRC=1 value=0x1
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_FIX_ROUND_LEN512_EMIT(xed_encoder_request_t* xes)
{
/* FIX_ROUND_LEN512()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_FIX_ROUND_LEN128_EMIT(xed_encoder_request_t* xes)
{
/* FIX_ROUND_LEN128()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_UISA_ENC_INDEX_ZMM_EMIT(xed_encoder_request_t* xes)
{
/* UISA_ENC_INDEX_ZMM()::
	INDEX=XED_REG_ZMM0  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_ZMM1  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_ZMM2  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_ZMM3  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_ZMM4  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_ZMM5  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_ZMM6  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_ZMM7  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_ZMM8  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_ZMM9  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_ZMM10  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_ZMM11  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_ZMM12  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_ZMM13  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_ZMM14  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_ZMM15  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_ZMM16  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_ZMM17  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_ZMM18  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_ZMM19  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_ZMM20  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_ZMM21  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_ZMM22  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_ZMM23  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_ZMM24  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_ZMM25  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_ZMM26  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_ZMM27  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_ZMM28  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_ZMM29  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_ZMM30  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_ZMM31  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_UISA_ENC_INDEX_YMM_EMIT(xed_encoder_request_t* xes)
{
/* UISA_ENC_INDEX_YMM()::
	INDEX=XED_REG_YMM0  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_YMM1  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_YMM2  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_YMM3  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_YMM4  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_YMM5  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_YMM6  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_YMM7  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_YMM8  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_YMM9  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_YMM10  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_YMM11  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_YMM12  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_YMM13  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_YMM14  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_YMM15  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_YMM16  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_YMM17  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_YMM18  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_YMM19  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_YMM20  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_YMM21  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_YMM22  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_YMM23  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_YMM24  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_YMM25  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_YMM26  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_YMM27  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_YMM28  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_YMM29  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_YMM30  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_YMM31  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_UISA_ENC_INDEX_XMM_EMIT(xed_encoder_request_t* xes)
{
/* UISA_ENC_INDEX_XMM()::
	INDEX=XED_REG_XMM0  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_XMM1  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_XMM2  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_XMM3  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_XMM4  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_XMM5  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_XMM6  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_XMM7  ->	FB VEXDEST4=0 value=0x0 	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_XMM8  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_XMM9  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_XMM10  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_XMM11  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_XMM12  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_XMM13  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_XMM14  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_XMM15  ->	FB VEXDEST4=0 value=0x0 	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_XMM16  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_XMM17  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_XMM18  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_XMM19  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_XMM20  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_XMM21  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_XMM22  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_XMM23  ->	FB VEXDEST4=1 value=0x1 	FB REXX=0 value=0x0 	FB SIBINDEX=7 value=0x7
	INDEX=XED_REG_XMM24  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=0 value=0x0
	INDEX=XED_REG_XMM25  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=1 value=0x1
	INDEX=XED_REG_XMM26  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=2 value=0x2
	INDEX=XED_REG_XMM27  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=3 value=0x3
	INDEX=XED_REG_XMM28  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=4 value=0x4
	INDEX=XED_REG_XMM29  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=5 value=0x5
	INDEX=XED_REG_XMM30  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=6 value=0x6
	INDEX=XED_REG_XMM31  ->	FB VEXDEST4=1 value=0x1 	FB REXX=1 value=0x1 	FB SIBINDEX=7 value=0x7
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_NELEM_QUARTER_EMIT(xed_encoder_request_t* xes)
{
/* NELEM_QUARTER()::
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ASZ_NONTERM_EMIT(xed_encoder_request_t* xes)
{
/* ASZ_NONTERM()::
	EASZ=1 MODE=0  ->	FB ASZ=0 value=0x0
	EASZ=2 MODE=0  ->	FB ASZ=1 value=0x1
	EASZ=2 MODE=1  ->	FB ASZ=0 value=0x0
	EASZ=1 MODE=1  ->	FB ASZ=1 value=0x1
	EASZ=3 MODE=2  ->	FB ASZ=0 value=0x0
	EASZ=2 MODE=2  ->	FB ASZ=1 value=0x1
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_ONE_EMIT(xed_encoder_request_t* xes)
{
/* ONE()::
	IMM_WIDTH=8 UIMM0=1 MODE=0  ->	nothing
	IMM_WIDTH=8 UIMM0=1 MODE=1  ->	nothing
	IMM_WIDTH=8 UIMM0=1 MODE=2  ->	nothing
 */
xed_uint_t okay=1;
return 1;
(void) okay;
(void) xes;
}
xed_uint_t xed_encode_nonterminal_UIMMv_EMIT(xed_encoder_request_t* xes)
{
/* UIMMv()::
	IMM_WIDTH=16 EOSZ=1 UIMM0[iiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiii emit_type=letters nbits=16
	IMM_WIDTH=32 EOSZ=2 UIMM0[iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii emit_type=letters nbits=32
	IMM_WIDTH=64 EOSZ=3 UIMM0[iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii emit_type=letters nbits=64
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_UIMMv;
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,64,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_SIMMz_EMIT(xed_encoder_request_t* xes)
{
/* SIMMz()::
	IMM_WIDTH=16 EOSZ=1 UIMM0[iiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiii emit_type=letters nbits=16 	FB IMM0SIGNED=1 value=0x1
	IMM_WIDTH=32 EOSZ=2 UIMM0[iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii emit_type=letters nbits=32 	FB IMM0SIGNED=1 value=0x1
	IMM_WIDTH=32 EOSZ=3 UIMM0[iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii emit_type=letters nbits=32 	FB IMM0SIGNED=1 value=0x1
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_SIMMz;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_SIMM8_EMIT(xed_encoder_request_t* xes)
{
/* SIMM8()::
	IMM_WIDTH=8 UIMM0[iiiiiiii]=*  ->	emit uimm0=iiiiiiii emit_type=letters nbits=8 	FB IMM0SIGNED=1 value=0x1
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_SIMM8;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_UIMM8_EMIT(xed_encoder_request_t* xes)
{
/* UIMM8()::
	IMM_WIDTH=8 UIMM0[iiiiiiii]=*  ->	emit uimm0=iiiiiiii emit_type=letters nbits=8
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_UIMM8;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_UIMM8_1_EMIT(xed_encoder_request_t* xes)
{
/* UIMM8_1()::
	DUMMY=0 UIMM1[iiiiiiii]=*  ->	emit uimm1=iiiiiiii emit_type=letters nbits=8
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_UIMM8_1;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_uimm1(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_UIMM16_EMIT(xed_encoder_request_t* xes)
{
/* UIMM16()::
	IMM_WIDTH=16 UIMM0[iiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiii emit_type=letters nbits=16
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_UIMM16;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_UIMM32_EMIT(xed_encoder_request_t* xes)
{
/* UIMM32()::
	IMM_WIDTH=32 UIMM0[iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii]=*  ->	emit uimm0=iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii emit_type=letters nbits=32
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_UIMM32;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_uimm0(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_BRDISP8_EMIT(xed_encoder_request_t* xes)
{
/* BRDISP8()::
	BRDISP_WIDTH=8 DISP[dddddddd]=*  ->	emit disp=dddddddd emit_type=letters nbits=8
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_BRDISP8;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_BRDISP32_EMIT(xed_encoder_request_t* xes)
{
/* BRDISP32()::
	BRDISP_WIDTH=32 DISP[dddddddddddddddddddddddddddddddd]=*  ->	emit disp=dddddddddddddddddddddddddddddddd emit_type=letters nbits=32
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_BRDISP32;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_BRDISPz_EMIT(xed_encoder_request_t* xes)
{
/* BRDISPz()::
	BRDISP_WIDTH=16 EOSZ=1 DISP[dddddddddddddddd]=*  ->	emit disp=dddddddddddddddd emit_type=letters nbits=16
	BRDISP_WIDTH=32 EOSZ=2 DISP[dddddddddddddddddddddddddddddddd]=*  ->	emit disp=dddddddddddddddddddddddddddddddd emit_type=letters nbits=32
	BRDISP_WIDTH=32 EOSZ=3 DISP[dddddddddddddddddddddddddddddddd]=*  ->	emit disp=dddddddddddddddddddddddddddddddd emit_type=letters nbits=32
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_BRDISPz;
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_MEMDISPv_EMIT(xed_encoder_request_t* xes)
{
/* MEMDISPv()::
	DISP_WIDTH=16 EASZ=1 DISP[aaaaaaaaaaaaaaaa]=*  ->	emit disp=aaaaaaaaaaaaaaaa emit_type=letters nbits=16
	DISP_WIDTH=32 EASZ=2 DISP[aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa]=*  ->	emit disp=aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa emit_type=letters nbits=32
	DISP_WIDTH=64 EASZ=3 DISP[aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa]=*  ->	emit disp=aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa emit_type=letters nbits=64
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_MEMDISPv;
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,64,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_MEMDISP32_EMIT(xed_encoder_request_t* xes)
{
/* MEMDISP32()::
	DISP_WIDTH=32 DISP[aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa]=*  ->	emit disp=aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa emit_type=letters nbits=32
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_MEMDISP32;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_MEMDISP16_EMIT(xed_encoder_request_t* xes)
{
/* MEMDISP16()::
	DISP_WIDTH=16 DISP[aaaaaaaaaaaaaaaa]=*  ->	emit disp=aaaaaaaaaaaaaaaa emit_type=letters nbits=16
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_MEMDISP16;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_MEMDISP8_EMIT(xed_encoder_request_t* xes)
{
/* MEMDISP8()::
	DISP_WIDTH=8 DISP[aaaaaaaa]=*  ->	emit disp=aaaaaaaa emit_type=letters nbits=8
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_MEMDISP8;
/* 1 */ if (iform==1) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
xed_uint_t xed_encode_nonterminal_MEMDISP_EMIT(xed_encoder_request_t* xes)
{
/* MEMDISP()::
	DISP_WIDTH=0  ->	FB NEED_MEMDISP=0 value=0x0
	DISP_WIDTH=8 DISP[aaaaaaaa]=*  ->	FB NEED_MEMDISP=8 value=0x8 	emit disp=aaaaaaaa emit_type=letters nbits=8
	DISP_WIDTH=16 DISP[aaaaaaaaaaaaaaaa]=*  ->	FB NEED_MEMDISP=16 value=0x10 	emit disp=aaaaaaaaaaaaaaaa emit_type=letters nbits=16
	DISP_WIDTH=32 DISP[aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa]=*  ->	FB NEED_MEMDISP=32 value=0x20 	emit disp=aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa emit_type=letters nbits=32
 */
xed_uint_t okay=1;
unsigned int iform = xed_encoder_request_iforms(xes)->x_MEMDISP;
/* 1 */ if (iform==1) {
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 4 */ if (iform==4) {
    xed_encoder_request_encode_emit(xes,8,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 2 */ if (iform==2) {
    xed_encoder_request_encode_emit(xes,16,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
/* 3 */ if (iform==3) {
    xed_encoder_request_encode_emit(xes,32,(xed3_operand_get_disp(xes)));
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
if (1) { /*otherwise*/
    if (xed3_operand_get_error(xes) != XED_ERROR_NONE) okay=0;
    return okay;
}
return 0; /*pacify the compiler*/
(void) okay;
(void) xes;
(void) iform;
}
